package es.jmillandel.senassistant.app;

import es.jmillandel.senassistant.app.R;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.content.IntentSender;
import android.content.SharedPreferences;
//import android.app.AlertDialog;
//import android.app.Dialog;
//import android.content.DialogInterface;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.Toast;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.FragmentTransaction;

import es.jmillandel.senassistant.bbdd.GestorSitios;
import es.jmillandel.senassistant.beans.DialogBoxAlert;
import es.jmillandel.senassistant.beans.DialogBoxConfirm;
import es.jmillandel.senassistant.beans.ExceptionApp;
import es.jmillandel.senassistant.beans.LocationUtils;
import es.jmillandel.senassistant.beans.Sitio;

import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;

import java.io.IOException;
import java.text.DecimalFormat;
import java.util.List;
import java.util.Locale;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesClient;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.android.gms.location.LocationClient;
import com.google.android.gms.location.LocationRequest;

/**
 * Clase que edita los datos de un sitio.
 * 
 * @author Juan Millan
 *
 */
public class EditarSitios extends FragmentActivity implements DialogBoxConfirm.DialogoBoxConfirmListener, LocationListener, GooglePlayServicesClient.ConnectionCallbacks, GooglePlayServicesClient.OnConnectionFailedListener, com.google.android.gms.location.LocationListener {
	public static final int CODIGO_RESPUESTA = 123;
	
	private String esAlta;
	private String clave;
	private GestorSitios gestorSitios;
	private Button btnSitiosCancelar;
	private Button btnSitiosGrabar;
	private Button btnSitiosEliminar;
	private Button btnSitiosActual;
	private Button btnSitiosMapa;
	private ImageButton ibtnSitiosAvisos;
	private EditText edtNombre;
	private EditText edtDireccion;
	private EditText edtLongitud;
	private EditText edtLatitud;
	private boolean alta;
	private boolean valido=true;
	private Sitio sitio=new Sitio();
	
	//Gestor del servicio de localizacin
	private LocationRequest mLocationRequest;
	private LocationClient mLocationClient;
    SharedPreferences mPrefs;
    SharedPreferences.Editor mEditor;
    boolean mUpdatesRequested = false;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.editar_sitios);
		
		try{
	        gestorSitios = new GestorSitios(this,GestorSitios.DB_NAME,null,GestorSitios.DB_VERSION);
	        gestorSitios.open();   
        }
        catch (Exception e){
        	showDialog(e.getMessage());
        	return;
        }
		
		Bundle bundle= getIntent().getExtras();
		esAlta=bundle.getString("esAlta");
		clave=bundle.getString("clave");
		
		edtNombre = (EditText) this.findViewById(R.id.edtSitioNombre);
		edtDireccion = (EditText) this.findViewById(R.id.edtSitioDireccion);
		edtLongitud = (EditText) this.findViewById(R.id.edtSitioLongitud);
		edtLatitud = (EditText) this.findViewById(R.id.edtSitioLatitud);
		
		btnSitiosCancelar = (Button) this.findViewById(R.id.btnSitiosCancelar);
		btnSitiosGrabar = (Button) this.findViewById(R.id.btnSitiosGrabar);
		btnSitiosEliminar = (Button) this.findViewById(R.id.btnSitiosEliminar);
		btnSitiosActual = (Button) this.findViewById(R.id.btnSitiosActual);
		btnSitiosMapa = (Button) this.findViewById(R.id.btnSitiosMapa);
		ibtnSitiosAvisos = (ImageButton) this.findViewById(R.id.ibtnSitiosAvisos);
		
		if (esAlta.equals("S")) {
			alta=true;
			btnSitiosEliminar.setEnabled(false);
			btnSitiosEliminar.setVisibility(View.INVISIBLE);
		} else {
			alta=false;
			cargarDatos();
		}
		
		//servicio GPS
		// parametros de Location
        mLocationRequest = LocationRequest.create();
        mLocationRequest.setInterval(LocationUtils.UPDATE_INTERVAL_IN_MILLISECONDS);
        mLocationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
        mLocationRequest.setFastestInterval(LocationUtils.FAST_INTERVAL_CEILING_IN_MILLISECONDS);
        mUpdatesRequested = true;

        // preferencias de la aplicacion
        mPrefs = getSharedPreferences(LocationUtils.SHARED_PREFERENCES, Context.MODE_PRIVATE);

        // editor para preferencias
        mEditor = mPrefs.edit();

        //cliente para Google location service
        mLocationClient = new LocationClient(this, this, this);
        	
	}
	
	@Override
    public void onStop() {
        if (mLocationClient.isConnected()) {
            stopPeriodicUpdates();
        }

        mLocationClient.disconnect();

        super.onStop();
    }

	@Override
    public void onStart() {
        super.onStart();
        
        btnSitiosCancelar.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
            	terminar();
            }
            
        });
        
        btnSitiosGrabar.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
            	grabarDatos();
            	if (valido) {
            		terminar();
            	}
            }
            
        });
        
        btnSitiosEliminar.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
            	showConfirm(getResources().getString(R.string.dialogo_confirmar));
            }
            
        });
        
        btnSitiosActual.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
            	startUpdates();
            	getLocation();
            	showDialog("Sitacion actualizada");
            }
            
        });
        
        btnSitiosMapa.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
            	lanzarMapa();
            }
            
        });
        
        ibtnSitiosAvisos.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {            	
            	lanzar();
            }
 
        });
        
      //inicio GPS
        mLocationClient.connect();
        
	}
	
	 @Override
	    public void onPause() {

	        // guardo la configuracion actual para updates
	        mEditor.putBoolean(LocationUtils.KEY_UPDATES_REQUESTED, mUpdatesRequested);
	        mEditor.commit();

	        super.onPause();
	    }
	 
	@Override
    public void onResume() {
        super.onResume();

        // recojo paramero para updates si hay
        if (mPrefs.contains(LocationUtils.KEY_UPDATES_REQUESTED)) {
            mUpdatesRequested = mPrefs.getBoolean(LocationUtils.KEY_UPDATES_REQUESTED, false);

        // detengo updates hasta que se vuelvan a pedir
        } else {
            mEditor.putBoolean(LocationUtils.KEY_UPDATES_REQUESTED, false);
            mEditor.commit();
        }

    }
	
	@Override
	public void onDestroy() {
		super.onDestroy();
		
		gestorSitios.close();
	}
	
	private void terminar() {
		gestorSitios.close();
    	finish();
	}
	
	/**
	 * lanza la pantalla avisos. Primero graba el sitio para
	 * poder enviar el identificador del sitio a Aviso.
	 * 
	 */
	private void lanzar() {
		if (alta) {
			//grabo para tener el id del sitio
			grabarDatos();
			if (valido) {
				//recupero sitio para obtener el id
				try {
					sitio=gestorSitios.getSitio(edtNombre.getText().toString());
					alta=false;
				} catch (ExceptionApp e) {
					showDialog(e.getMessage());
				}
			}
		}
		
		if (valido) {
			Intent pantallaAvisos = new Intent();
			pantallaAvisos.putExtra("idSitio",sitio.getIdSitio());
			pantallaAvisos.setClass(this,PantallaAvisos.class);
	    	startActivity(pantallaAvisos);
		}
		
	}
	
	/**
	 * lanza buscar en mapa una direccion para obtener
	 * la posicion.
	 * 
	 */
	private void lanzarMapa() {
		Intent buscarMapa = new Intent();
		buscarMapa.setClass(this,BuscarEnMapa.class);
		startActivityForResult( buscarMapa, CODIGO_RESPUESTA );
	}
	
	private void cargarDatos() {
		if (!alta && clave.length()==0){
			alta=true;
		}
		
		if (!alta) {
			try {
				sitio = gestorSitios.getSitio(clave);
				if (sitio==null) {
					sitio=new Sitio();
					alta=true;
					
				} else {
					edtNombre.setText(sitio.getNombre());
					edtDireccion.setText(sitio.getDireccion());
					edtLongitud.setText(String.valueOf(sitio.getLongitud()));
					edtLatitud.setText(String.valueOf(sitio.getLatitud()));
				}
			} catch (ExceptionApp e) {
				showDialog(e.getMessage());
			}
		}
	}
	
	private void grabarDatos() {
		if (checkData()) {
			sitio.setNombre(edtNombre.getText().toString());
			sitio.setDireccion(edtDireccion.getText().toString());
			sitio.setLongitud(Double.parseDouble(edtLongitud.getText().toString()));
			sitio.setLatitud(Double.parseDouble(edtLatitud.getText().toString()));
			
			try {
				if (alta){
					gestorSitios.altaSitio(sitio);
				} else {
					gestorSitios.modSitio(sitio);
				}
			} catch (ExceptionApp e) {
				showDialog(e.getMessage());
			}
		}
		
	}
	
	private void borrarDatos() {
		try {
			gestorSitios.bajaSitio(sitio);
		} catch (ExceptionApp e) {
			showDialog(e.getMessage());
		}
	}
	
	private boolean checkData() {
		valido=true;
		
		if (edtNombre.getText().length()==0) {
			showDialog(getResources().getString(R.string.dialogo_sin_nombre));
			valido=false;
		}
		
		if (edtDireccion.getText().length()==0) {
			showDialog(getResources().getString(R.string.dialogo_sin_direccion));
			valido=false;
		}
		
		if (edtLongitud.getText().length()==0) {
			showDialog(getResources().getString(R.string.dialogo_sin_longitud));
			valido=false;
		}
		
		if (edtLatitud.getText().length()==0) {
			showDialog(getResources().getString(R.string.dialogo_sin_latitud));
			valido=false;
		}
		
		// compruebo si ya existe el nombre
		try {
			if (alta && gestorSitios.getSitio(edtNombre.getText().toString())!=null) {
				showDialog(getResources().getString(R.string.dialogo_existe_sitio_nombre));
				valido=false;
			}
		} catch (ExceptionApp e) {
			showDialog(e.getMessage());
			valido=false;
		}
		
		return valido;
	}
	
	/**
	 * muestra una alerta.
	 * 
	 * @param texto
	 */
	private void showDialog(String texto){
		DialogFragment df = new DialogBoxAlert(texto);
	    df.show(getSupportFragmentManager(), getResources().getString(R.string.dialogo_titulo));
	}
	
	/**
	 * pide confirmacion.
	 * 
	 * @param texto
	 */
	private void showConfirm(String texto){
		DialogFragment df = new DialogBoxConfirm(texto);
	    df.show(getSupportFragmentManager(), getResources().getString(R.string.dialogo_titulo_confirma));
	}
	
	@Override
    public void onDialogPositiveClick(DialogFragment dialog) {
		borrarDatos();
    	terminar();
    }

    @Override
    public void onDialogNegativeClick(DialogFragment dialog) {
    	// no hacer nada
    }
         
     public void muestraPosicionActual(Location loc){
        if(loc == null){
        	edtLongitud.setText("0");
        	edtLatitud.setText("0");
        }else{
        	edtLongitud.setText(String.valueOf(loc.getLongitude()));
        	edtLatitud.setText(String.valueOf(loc.getLatitude()));
           
        }
     }
     
     /**
      * metodo para atender los resultados devueltos por  onConnectionFailed 
      * de LocationUpdateRemover, LocationUpdateRequester Y BuscarEnMapa.
      */
     @Override
     protected void onActivityResult(int requestCode, int resultCode, Intent intent) {

         switch (requestCode) {

             // enviado por onConnectionFailed
             case LocationUtils.CONNECTION_FAILURE_RESOLUTION_REQUEST :

                 switch (resultCode) {
                     // si Google resolvio el problema
                     case Activity.RESULT_OK:
                    	 // nada
                    	 break;

                     // si no
                     default:
                    	 showDialog(getResources().getString(R.string.error_google_contectar));
                    	 break;
                 }
              
             case CODIGO_RESPUESTA:
            	 if (resultCode == Activity.RESULT_OK ) {
                     String dato = intent.getExtras().getString(BuscarEnMapa.DATO_DEVUELTO1 );
                     edtLatitud.setText(dato);
                     dato = intent.getExtras().getString(BuscarEnMapa.DATO_DEVUELTO2 );
                     edtLongitud.setText(dato);
            	 }
            	 break;

             // otro codigo
             default:
            	 showDialog(getResources().getString(R.string.error_google_servicio));
                break;
         }
     }
     
     /**
      * Comprueba si los servicios de Google estan disponibles.
      *
      * @return true si estan disponibles, false si no
      */
     private boolean servicesConnected() {

         int resultCode = GooglePlayServicesUtil.isGooglePlayServicesAvailable(this);

         if (ConnectionResult.SUCCESS == resultCode) {
             return true;
         } else {
        	 showDialog(getResources().getString(R.string.error_google_servicio));
             return false;
         }
     }
     
     public void getLocation() {
         if (servicesConnected()) {
             Location currentLocation = mLocationClient.getLastLocation();
             muestraPosicionActual(currentLocation);
         }
     }    

     public void startUpdates() {
         mUpdatesRequested = true;

         if (servicesConnected()) {
             startPeriodicUpdates();
         }
     }

     public void stopUpdates() {
         mUpdatesRequested = false;

         if (servicesConnected()) {
             stopPeriodicUpdates();
         }
     }
     
     @Override
     public void onConnected(Bundle bundle) {
         if (mUpdatesRequested) {
             startPeriodicUpdates();
         }
     }

     @Override
     public void onDisconnected() {
         
     }

     @Override
     public void onConnectionFailed(ConnectionResult connectionResult) {

         if (connectionResult.hasResolution()) {
             try {
                 //intento solucionar el error
                 connectionResult.startResolutionForResult(this, LocationUtils.CONNECTION_FAILURE_RESOLUTION_REQUEST);
                 
             } catch (IntentSender.SendIntentException e) {
            	 showDialog(e.getMessage());
             }
         } else {

             // si no tiene solucion muestro el error
        	 showDialog(String.valueOf(connectionResult.getErrorCode()));
         }
     }

     @Override
     public void onLocationChanged(Location location) {

     }

     private void startPeriodicUpdates() {
         mLocationClient.requestLocationUpdates(mLocationRequest, this);
     }

     private void stopPeriodicUpdates() {
         mLocationClient.removeLocationUpdates(this);
     }

	@Override
	public void onProviderDisabled(String provider) {
		
		
	}

	@Override
	public void onProviderEnabled(String provider) {
		
	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		
	}

}
