package es.jmillandel.senassistant.beans;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;

import es.jmillandel.senassistant.app.R;

/**
 * Clase que define una ventana de dialogo para avisos.
 * Solo dispone del boton aceptar.
 * 
 * @author Juan Millan
 *
 */
public class DialogBoxAlert extends DialogFragment {
	private String texto;
	
	public DialogBoxAlert(String texto) {
		this.texto=texto;
	}

	@Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setMessage(texto)
               .setPositiveButton(R.string.dialogo_aceptar, new DialogInterface.OnClickListener() {
                   public void onClick(DialogInterface dialog, int id) {
                       // no hacer nada
                   }
               });

        // Crea el AlertDialog
        return builder.create();
    }

}
