package es.jmillandel.senassistant.beans;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;

import es.jmillandel.senassistant.app.R;

/**
 * Clase que define una ventana de dialogo para confirmar.
 * Dispone de botones aceptar y cancelar.
 * 
 * @author Juan Millan
 *
 */
public class DialogBoxConfirm extends DialogFragment {
	private String texto;
	
	public DialogBoxConfirm(String texto) {
		this.texto=texto;
	}
	
	public interface DialogoBoxConfirmListener {
        public void onDialogPositiveClick(DialogFragment dialog);
        public void onDialogNegativeClick(DialogFragment dialog);
    }
	
	DialogoBoxConfirmListener mListener;
	
	@Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        try {
            mListener = (DialogoBoxConfirmListener) activity;
        } catch (ClassCastException e) {
            throw new ClassCastException(activity.toString()
                    + " "+R.string.error_no_interface);
        }
    }

	@Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setMessage(texto)
               .setPositiveButton(R.string.dialogo_aceptar, new DialogInterface.OnClickListener() {
                   public void onClick(DialogInterface dialog, int id) {
                	   mListener.onDialogPositiveClick(DialogBoxConfirm.this);
                   }
               })
               .setNegativeButton(R.string.dialogo_cancelar, new DialogInterface.OnClickListener() {
                   public void onClick(DialogInterface dialog, int id) {
                	   mListener.onDialogNegativeClick(DialogBoxConfirm.this);
                   }
               });
        // Crea el AlertDialog
        return builder.create();
    }

}
