/*
 * Copyright (C) 2013 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package es.jmillandel.senassistant.beans;

/**
 * Clase que define constantes para location
 * 
 */
public final class LocationUtils {

    public static final String SHARED_PREFERENCES = "es.jmillandel.senass.SHARED_PREFERENCES";
    public static final String KEY_UPDATES_REQUESTED = "es.jmillandel.senass.KEY_UPDATES_REQUESTED";

    /*
     * codigo para enviar a los servicios de Google play
     * se devuelve en Activity.onActivityResult
     */
    public final static int CONNECTION_FAILURE_RESOLUTION_REQUEST = 2001;

    public static final int MILLISECONDS_PER_SECOND = 1000;
    public static final int UPDATE_INTERVAL_IN_SECONDS = 5;
    public static final int FAST_CEILING_IN_SECONDS = 1;
    public static final long UPDATE_INTERVAL_IN_MILLISECONDS = MILLISECONDS_PER_SECOND * UPDATE_INTERVAL_IN_SECONDS;
    public static final long FAST_INTERVAL_CEILING_IN_MILLISECONDS = MILLISECONDS_PER_SECOND * FAST_CEILING_IN_SECONDS;
    
    // parametros seguimiento
    public static final double MIN_DISTANCE_TRACE = 2.0;
    public static final double MAX_DISTANCE_TRACE = 10.0;
    public static final double EXIT_DISTANCE_TRACE = 30.0;
    
    // parametros sensor
    public static final double MAX_ACCELERATION = 18.0;
    public static final long CHECK_FALL_IN_MILLISECONDS = 120000;
}
